#version 150

#moj_import <fog.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;

in float vertexDistance;
in vec2 texCoord0;
in vec4 vertexColor;
in vec4 light;

out vec4 fragColor;

bool CompareColors(vec3 a, vec3 b, float s)
{
    return abs(a.r - b.r) <= s && abs(a.g - b.g) <= s && abs(a.b - b.b) <= s;
}

void main() {
    vec4 col = vertexColor;
    if (CompareColors(col.rgb, vec3(168, 88, 33) / 255, 0.01))
        col.rgb = vec3(135, 98, 61) / 255;

    vec4 color = texture(Sampler0, texCoord0) * col * light * ColorModulator;

    if (color.a < 0.1)
        discard;

    fragColor = linear_fog(color, vertexDistance, FogStart, FogEnd, FogColor);
}
